/* ************************************************************************* */
/* debug.h: Simple debug macro.                                              */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */

#include <stdio.h>

#ifndef __DEBUG_MACRO__
#define __DEBUG_MACRO__

#ifdef USE_DEBUG_MACRO

#define DEBUG(LVL,FORMAT, ARGS...) \
if (debug_level>=LVL) { \
 fprintf(stderr,"%s:%d  " #FORMAT  "\n",__FILE__,__LINE__, ##ARGS); }
#define DEBUG_INIT() int debug_level=0

#define SET_DEBUG_LEVEL(lvl) debug_level=lvl
#define IS_DEBUG_LEVEL(lvl) (debug_level>=lvl)
extern int debug_level; 
#else
#define DEBUG_INIT() int debug_level=0
#define DEBUG(LVL,FORMAT,ARGS...)
#define SET_DEBUG_LEVEL(lvl)
#define IS_DEBUG_LEVEL(LVL)
#endif
#endif

