/* ************************************************************************* */
/* dyn_array.h: Function prototypes for a simple array with dynamic size     */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */


#ifndef __DYN_ARRAY_H__
#define __DYN_ARRAY_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "iopasm_types.h"

 
/* ************************************************************************* */
/*                               PROTOTYPES                                  */
/* ************************************************************************* */
array_t *create_array(int (*cmp_func)(void *,void *),void (*destrudo)(void *));
int add_array_elem(array_t *array,void *elem);
void *find_array_elem(array_t *array,void *elem);
int delete_elem(array_t *array,void *elem);
int delete_array(array_t *array);
void array_iterator(void *ctxt,array_t *array,void *dst,
		    int (*for_each)(void *context,void *dst,void *elem));
void *get_array_elem(array_t *array,int elem);
unsigned int get_array_size(array_t *array);
int find_array_elem_pos(array_t *array,void *elem);
void set_array_elem(array_t *array,int pos,void *elem);
#endif /* dyn_array.h */
