/* ************************************************************************* */
/* dyn_stack.h: Prototypes for the dynamic stack implementation.             */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */


#ifndef __DYN_STACK_H__
#define __DYN_STACK_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include <stdarg.h>
#include <stdio.h>
#include "iopasm_types.h"


/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */



/* ************************************************************************* */
/*                               PROTOTYPES                                  */
/* ************************************************************************* */
dyn_stack_t *create_stack(void (*destructor)(void *),
			  void *(*loader)(FILE *),
			  int (*saver)(FILE *,void *));
void *stack_pop(dyn_stack_t *a_stack);
void stack_push(dyn_stack_t *a_stack,void *an_elem);
int get_stack_depth(dyn_stack_t *a_stack);
void delete_stack(dyn_stack_t *a_stack);
void stack_iterator(dyn_stack_t *a_stack,
		    void (*for_each)(void *data,va_list *c_args),...);
void *stack_peek(dyn_stack_t *a_stack);
void invert_stack(dyn_stack_t *a_stack);
dyn_stack_t *load_stack_object(FILE *in_file,
			       void (*destructor)(void *),
			       void *(*loader)(FILE *),
			       int (*saver)(FILE *,void *));
int save_stack_object(FILE *out_file,dyn_stack_t *stack);
void dump_stack_object(FILE *in_file,void *object,
		       void (*object_dump)(FILE *in_file,meta_object_t *object));
#endif /* end of ifndef __DYN_STACK_H__ */
/* end of dyn_stack.h */
