/* ************************************************************************* */
/* etrax_fs_mpu_be.h: Function prototypes for ETRAX FS MPU code generation   */
/*                    backend                                                */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */




#ifndef __ETRAX_FS_MPU_BE_H__
#define __ETRAX_FS_MPU_BE_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "i_table.h"
#include "p_list.h"
#include "dyn_array.h"
#include "cg_fe.h"
#include "debug.h"


/* ************************************************************************* */
/*                                    PROTOTYPES                             */
/* ************************************************************************* */
int etrax_fs_mpu_set_tables(cg_context_t *ctxt);
int etrax_fs_mpu_gen_seq(cg_context_t *seq_context,inst_t *inst,int pass,
		   int scope);
int etrax_fs_mpu_gen_fsm(cg_context_t *seq,inst_t *first,inst_t *last,
			 int pass);
unsigned int etrax_fs_mpu_conv_pc_seq(unsigned int val);
unsigned int etrax_fs_mpu_conv_pc_fsm(unsigned int val);
void etrax_fs_mpu_finish(cg_context_t *ctxt,plist_t *a_list);
plist_t *etrax_fs_mpu_fsm_optimizer(cg_context_t *ctxt,plist_t *a_list);
#endif  /* End of #ifndef __ETRAX_FS_MPU_BE_H__ */
/* end of etrax_fs_mpu_be.h */
