/* ************************************************************************* */
/* fsm_optimizer.h : Prototypes for architecture independent parts of the    */
/*                   FSM optimizer.                                          */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */


#ifndef __FSM_OPTIMIZER_H__
#define __FSM_OPTIMIZER_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "cg_fe.h"
#include "iopasm_err.h"
#include "iopasm_types.h"
#include "matrix.h"
#include "optimizer_sets.h"
#include "p_list.h"
#include "state_descriptor.h"



/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                              CONSTANT VARIABLES                           */
/* ************************************************************************* */



/* ************************************************************************* */
/*                                 PROTOTYPES                                */
/* ************************************************************************* */
plist_t *optimize_states(cg_context_t *ctxt,plist_t *the_list);
int match_rows_in_set(matrix_t *the_matrix,optset_t *a_set,
		      int start_row,int max_rows,int max_cols);
void fill_opt_set(optset_t *the_set,matrix_t *a_matrix,
		  int fill_row,int rows,int cols);
void dump_state_matrix(matrix_t *a_matrix);
void add_dependent_state(matrix_t *the_matrix,state_t *a_state,int row);
int get_row_count(matrix_t *a_matrix,int row,int start_col);
int match_dependent_rows(matrix_t *the_matrix,int start_row,
			 int n_rows,int n_cols);
void calc_optset_size(cg_context_t *ctxt,optset_t *a_set);
int relocate_seq_code(cg_context_t *ctxt,plist_t *dest,plist_t *src);
int is_entry_point(cg_context_t *ctxt,matrix_t *a_matrix,int this_row);
matrix_t *build_dep_matrix(cg_context_t *ctxt,plist_t *the_list,
			   int max_rows,int max_cols);
int build_dep_sets(cg_context_t *ctxt,matrix_t *state_matrix,
		   array_t *found_sets,optset_t *indep_states);
#endif /* end of fsm_optimizer.h */

