/* ************************************************************************* */
/* global_rules.h : Prototypes for architecture independent rules            */
/*                  implemented in global_rules.c                            */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */



#ifndef __GLOBAL_RULES_H__
#define __GLOBAL_RULES_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "p_list.h"
#include "cg_fe.h"
#include "i_table.h"

/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                              CONSTANT VARIABLES                           */
/* ************************************************************************* */



/* ************************************************************************* */
/*                                  PROTOTYPES                               */
/* ************************************************************************* */
int validate_delay_slot(cg_context_t *ctxt,inst_t *inst,int i_num,
		      unsigned char *buf,int buf_size);

int validate_dest_register(cg_context_t *ctxt,inst_t *inst,int i_num,
			   unsigned char *buf,int buf_size);

int arg2_range_check(cg_context_t *ctxt,inst_t *inst,int i_num,
		     unsigned char *buf,int buf_size);
#endif /* End of #ifndef __GLOBAL_RULES_H__ */
/* End of file: global_rules.h */
