/* ************************************************************************* */
/* iopasm_types.h : Defines all new data types used in the I/) processor     */
/*                  assembler.                                               */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */




#ifndef __IOPASM_TYPES_H__
#define __IOPASM_TYPES_H__
/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */
typedef struct __itable_collections itable_table;
typedef struct __cg_context_t cg_context_t;
typedef struct __cg_backend_t cg_backend_t;
typedef struct __cg_operator_t cg_operator_t;

typedef struct __array_t array_t;
typedef struct __serror_t serror_t; /* Holds Error/warnings = On/Off       */
typedef struct __stack_t dyn_stack_t;
typedef struct __fsm_symbol_t fsm_symbol_t;
typedef struct __label_t label_t;

typedef struct __meta_object_t meta_object_t;
typedef struct __object_header_t object_header_t;

typedef struct __arg_t arg_t;
typedef struct __inst_t inst_t;
typedef struct __plist_t plist_t;

typedef struct __matrix_t matrix_t;

typedef struct __inst_table_t inst_table_t;
typedef struct __reg_table_t reg_table_t;
typedef struct __mem_table_t mem_table_t;

typedef struct __optset_t__ optset_t;   /* Optimizer set */
typedef struct __state_t__ state_t;     /* State description type */

struct __cg_operator_t {
  char *operator;
  int (*operator_func)(cg_context_t *ctxt,void *meta_buffer,
		       int mbuf_len,void *buffer,
		       int buf_len,inst_t *inst,int inum,
		       arg_t *arg1,arg_t *arg2,int arg_no);
};

#endif /* matches  __IOPASM_TYPES_H__ */
/* end of iopasm_types.h */
