/* ************************************************************************* */
/* load_operations.h : Prototypes for module implementing load_operations    */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */


#ifndef __LOAD_OPERATIONS_H__
#define __LOAD_OPERATIONS_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include <stdio.h>
#include <stdlib.h>
#include "iopasm_global.h"
#include "cg_fe.h"
#include "p_list.h"
#include "dyn_array.h"
#include "labels.h"
#include "meta_object.h"



/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                              CONSTANT VARIABLES                           */
/* ************************************************************************* */



/* ************************************************************************* */
/*                             FUNCTION PROTOTYPES                           */
/* ************************************************************************* */
void load_symbol_file(array_t *labels,char *file_name);
void load_object_file(cg_context_t *ctxt,plist_t *list,char *file_name);
void dump_object_file(char *file_name,cg_context_t *ctxt);
#endif /* #ifndef __LOAD_OPERATIONS_H__ */
/* end of load_operations.h */
