/* ************************************************************************* */
/* matrix.h: Simple state transition matrix                                  */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */



#ifndef __MATRIX_H__
#define __MATRIX_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "iopasm_types.h"

/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */


/* ************************************************************************* */
/*                           FUNCTION PROTOTYPES                             */
/* ************************************************************************* */
void add_matrix_elem(matrix_t *a_matrix,int row,int col,void *elem);
void *get_matrix_elem(matrix_t *a_matrix,int row,int col);
matrix_t *create_matrix(int rows,int cols,int data_size,
			void (*destructor)(void *));

int get_matrix_rows(matrix_t *a_matrix);
int get_matrix_columns(matrix_t *a_matrix);
void clear_matrix_row(matrix_t *the_matrix,int clear_this_row,int cols);
void delete_matrix(matrix_t *the_matrix);
#endif /* end ifndef __MATRIX_H__ */
/* of template.h */
