/* ************************************************************************* */
/* meta_object.h : Definitions and protoypes for meta object type used       */
/*                 to tag objects before saving them                         */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */
/*                                                                           */
/*   Date      Description                                          Sign.    */
/*  =======================================================================  */
/*  2003-04-03 Module implemented                                   JohanJ   */
/* ************************************************************************* */


#ifndef __META_OBJECT_H__
#define __META_OBJECT_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include <stdlib.h>
#include <stdio.h>
#include "iopasm_types.h"

/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */
#define CTXT_ELEM            (3)
#define INST_LIST_ELEM       (4)
#define ARG_LIST_ELEM        (5)
#define LABEL_ELEM           (6)
#define SRC_FILENAME_ELEM    (7)
#define ARG_STACK_ELEM       (8)


#define META_OBJECT_SIZE (sizeof(struct __meta_object_t))





/* ************************************************************************* */
/*                              CONSTANT VARIABLES                           */
/* ************************************************************************* */


/* ************************************************************************* */
/*                                    PROTOTYPES                             */
/* ************************************************************************* */
meta_object_t *create_meta_object(int type,int size);
int get_object_size(meta_object_t *object);
int get_object_type(meta_object_t *object);
void delete_meta_object(meta_object_t *object);
void save_meta_object(FILE *file,meta_object_t *object) ;
meta_object_t *load_meta_object(FILE *file);
void save_object_header(FILE *out_file,cg_context_t *ctxt,
			unsigned int n_objects);
unsigned int chk_object_header(char *file_name,FILE *in_file,
			       cg_context_t *ctxt);
unsigned int dump_object_header(FILE *in_file,cg_context_t *ctxt);
void dump_meta_object(meta_object_t *object);
char *load_obj_string(FILE *file,meta_object_t *object);
#endif /* End of ifndef __META_OBJECT_H__ */

/* End of meta_object.h */
