/* ************************************************************************* */
/* optimizer_sets.h:  Contains definitions for platform independent sets     */
/*                    used by the optimizer.                                 */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/*                                                                           */
/*   Date      Description                                          Sign.    */
/*  =======================================================================  */
/*  2004-10-22 Module implemented                                   JohanJ   */
/* ************************************************************************* */



#ifndef __OPTIMIZER_SETS_H__
#define __OPTIMIZER_SETS_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "iopasm_global.h"
#include "iopasm_types.h"




/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */
optset_t *optset_create();
int optset_add_state(optset_t *a_set,state_t *a_state);
void optset_dump(optset_t *a_set);
int optset_is_state_in_set(optset_t *a_set,state_t *a_state);
unsigned int optset_get_size(optset_t *a_set);
void optset_set_size(optset_t *a_set,unsigned int size);
state_t *optset_get_state_by_index(optset_t *a_set,int which);
int optset_get_state_count(optset_t *a_set);


int optset_get_empty_max(optset_t *a_set);
int optset_get_max_rows(optset_t *a_set);
int opset_get_fragmentation(optset_t *a_set);

void opset_set_fragmentation(optset_t *a_set,int fragmentation);
void optset_set_max_rows(optset_t *a_set,int rows);
void optset_set_empty_max(optset_t *a_set,int empty);
void optset_delete(void *a_set);
optset_t *optset_union(optset_t *set_1,optset_t *set_2);
state_t *optset_find_sized_state(optset_t *set1,int mx_size,int decrement);
#endif /* end of #ifndef __OPTIMIZER_SETS_H__ */
/* end of optimizer_sets.h */
