/* ************************************************************************* */
/* parser.h : Function prototypes for parser help functions                  */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/*                                                                           */
/*   Short revision history:                                                 */
/*                                                                           */
/*   Date      Description                                          Sign.    */
/*  =======================================================================  */
/*  2004-07-07 Prototypes moved here during major clean up          JohanJ   */
/* ************************************************************************* */



#ifndef __PARSER_H__
#define __PARSER_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include <assert.h>
#include <stdio.h>
#include <stdarg.h>
#include "cg_fe.h"
#include "labels.h"
#include "p_list.h"

/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */
int add_instruction(plist_t *a_list,char *i_text,int i_type,int size,int i_flags);
void resolve_labels(cg_context_t *ctxt, plist_t *a_list);
void resolver_iterator(void *data,va_list *c_args);
void find_bw_reference(cg_context_t *ctxt,inst_t *inst,arg_t *arg);
void find_fw_reference(cg_context_t *ctxt,inst_t *inst,arg_t *arg);
char *duplicate_string(char *string);
void add_new_raw_arg(cg_context_t *ctxt,plist_t *i_list,char *arg_text);
void add_argument(cg_context_t *ctxt,plist_t *a_list,char *arg_text,int arg_type);

void add_label(cg_context_t *ctxt,plist_t *i_list,char *label,int scope);
void push_arg(plist_t *i_list,char *text,int type);
#endif /* end of parser.h */
