/* ************************************************************************* */
/* save_operations.h: Prototypes for various functions used to save output   */
/*                                                                           */
/*    Copyright 2002-2004 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */



#ifndef __SAVE_OPERATIONS_H__
#define __SAVE_OPERATIONS_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "cg_fe.h"
#include "p_list.h"

/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */
#define SYM_FILE_FMT_SYMBOLS (1)
#define SYM_FILE_FMT_HEADER  (2)


/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */
void save_list_file(char *list_fname,cg_context_t *ctxt,plist_t *a_list,
		    plist_t *optimized_liset);
void save_binary_file(char *bin_fname,cg_context_t *ctxt,
		      plist_t *a_list,unsigned char *bin_buffer);
void save_symbol_file(char *file_name,int file_type,cg_context_t *ctxt,
		      plist_t *a_list);
void save_header_file(char *file_name,cg_context_t *ctxt);
void save_object_file(char *file_name,cg_context_t *ctxt,plist_t *list);
void save_vlog64_file(char *vlog64_fname,cg_context_t *ctxt,
		      plist_t *a_list,unsigned char *bin_buffer);
void save_vlog256_file(char *vlog256_fname,cg_context_t *ctxt,
		       plist_t *a_list,unsigned char *bin_buffer);
void save_c_macros(char *file_name,cg_context_t *ctxt);

#endif /* End of save_operations.h */
