/* ************************************************************************* */
/* stack_eval.h : Prototypes for stack evaluation module.                    */
/*                                                                           */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/*                                                                           */
/*   Date      Description                                          Sign.    */
/*  =======================================================================  */
/*  2003-09-05 Header file created                                   JohanJ  */
/* ************************************************************************* */


#ifndef __STACK_EVAL_H__
#define __STACK_EVAL_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */
#include "cg_fe.h"
#include "dyn_stack.h"
#include "p_list.h"


/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */


/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */
unsigned int eval_arg_stack(cg_context_t *ctxt,inst_t *inst,int inum,
			    arg_t *arg_stack,int *meta_data,
			    int arg_no,int pass);
void minimize_stacks(cg_context_t *ctxt,inst_t *inst,int pass);
void count_registers(void *val,void *argument);
int check_expression_type(dyn_stack_t *a_stack);
int convert_stack_arg(cg_context_t *ctxt,inst_t *inst,arg_t *arg,int pass);
#endif /* End of __STACK_EVAL_H__ */
/* End of stack_eval.h */
