/* ************************************************************************* */
/* state_descriptor.h: Prototypes for state descriptor data type functions   */
/*                                                                           */
/*    Copyright 2002-2006 Axis Communications AB.                            */
/*                                                                           */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 59 Temple Place - Suite 330,                         */
/*    Boston, MA 02111-1307, USA.                                            */
/*                                                                           */
/*                                                                           */
/*    Send bug reports and inquiries to Johan.Jorgensen@axis.com             */
/* ************************************************************************* */



#ifndef __STATE_DESCRIPTOR_H__
#define __STATE_DESCRIPTOR_H__
/* ************************************************************************* */
/*                      INCLUDES USED BY THIS MODULE                         */
/* ************************************************************************* */


/* ************************************************************************* */
/*                       TYPES DEFINED IN THIS MODULE                        */
/* ************************************************************************* */


/* ************************************************************************* */
/*                     DEFINITIONS LOCAL TO THIS MODULE                      */
/* ************************************************************************* */



/* ************************************************************************* */
/*                                PROTOTYPES                                 */
/* ************************************************************************* */
state_t *create_state(char *state_name,inst_t *start,inst_t *end,int size);
void delete_state(void *a_state);
void set_state_end(state_t *a_state,inst_t *state_end);
void set_state_start(state_t *a_state,inst_t *state_start);
void set_state_name(state_t *a_state,char *state_name);
void set_state_size(state_t *a_state,unsigned int size);
char *get_state_name(state_t *a_state);
inst_t *get_state_end(state_t *a_state);
unsigned int get_state_size(state_t *a_state);
inst_t *get_state_start(state_t *a_state);
int cmp_states(void *s1, void *s2);
void clone_state(state_t *dest,state_t *src);
state_t *copy_state(state_t *src);

#endif /* Matches __STATE_DESCRIPTOR_H__ */

/* End of state_descriptor.h */
